package models

import (
	"database/sql"
	"errors"
	"os"

	_ "github.com/lib/pq"
)

var db *sql.DB

func InitDatabase() error {
	connection := os.Getenv("DB_CONNECTION")

	if len(connection) == 0 {
		return errors.New("DB_CONNECTION env was not found.")
	}

	database, err := sql.Open("postgres", connection)

	db = database

	return err
}
