package models

import (
	"fmt"
	"screenmark/screenmark/.gen/haystack/haystack/model"
	. "screenmark/screenmark/.gen/haystack/haystack/table"

	. "github.com/go-jet/jet/v2/postgres"
	"github.com/google/uuid"
)

// Raw dogging SQL is kinda based though?
//
// |            nO, usE OrM!!
//
// |        RAW      -     RAW
// |        SQL     | \    SQL
// |        GOOD   |   \   GOOD
// |              -     -
// |            --       --
// |           --         --
// |       ----      IQ     ----
func getNonExistantTags(userId uuid.UUID, tags []string) ([]string, error) {
	values := ""
	counter := 1
	// big big SQL injection problem here?
	for counter = 1; counter <= len(tags); counter++ {
		values += fmt.Sprintf("($%d),", counter)
	}
	values = values[0 : len(values)-1]

	/*
		WITH given_tags
		        AS (SELECT given_tags.tag FROM (VALUES ('c')) AS given_tags (tag)),
		this_user_tags as (
			SELECT id, tag
		                FROM haystack.user_tags
		                where user_tags.user_id = 'fcc22dbb-7792-4595-be8e-d0439e13990a'
		)
		select given_tags.tag from given_tags
		                LEFT OUTER JOIN this_user_tags ON this_user_tags.tag = given_tags.tag
		                where this_user_tags.tag is null;
	*/

	withStuff := fmt.Sprintf(`WITH given_tags 
        AS (SELECT given_tags.tag FROM (VALUES `+values+`) AS given_tags (tag)),
        this_user_tags AS 
        (SELECT id, tag FROM haystack.user_tags WHERE user_tags.user_id = $%d)
		SELECT given_tags.tag
		FROM given_tags
		LEFT OUTER JOIN haystack.user_tags ON haystack.user_tags.tag = given_tags.tag
		where user_tags.tag is null`, counter)

	stmt, err := db.Prepare(withStuff)
	fmt.Println(withStuff)

	if err != nil {
		fmt.Println("failing to prepare stmt")
		return []string{}, err
	}

	defer stmt.Close()

	args := make([]any, counter)
	for i, v := range tags {
		args[i] = v
	}
	args[counter-1] = userId.String()

	rows, err := stmt.Query(args...)
	if err != nil {
		return []string{}, err
	}

	nonExistantTags := make([]string, 0)

	for rows.Next() {
		var tag string
		rows.Scan(&tag)

		nonExistantTags = append(nonExistantTags, tag)
	}

	return nonExistantTags, nil
}

func CreateTags(userId uuid.UUID, tags []string) error {
	tagsToInsert, err := getNonExistantTags(userId, tags)
	if err != nil {
		return err
	}

	if len(tagsToInsert) == 0 {
		return nil
	}

	stmt := UserTags.INSERT(UserTags.UserID, UserTags.Tag)

	for _, tag := range tagsToInsert {
		stmt = stmt.VALUES(UUID(userId), tag)
	}

	_, err = stmt.Exec(db)

	return err
}

func GetTags(userId uuid.UUID) ([]model.UserTags, error) {
	stmt := UserTags.SELECT(UserTags.AllColumns).WHERE(UserTags.UserID.EQ(UUID(userId)))

	userTags := []model.UserTags{}

	err := stmt.Query(db, &userTags)

	return userTags, err
}
